Attribute VB_Name = "API"
Option Explicit

Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Function GetFromINI(Section As String, Key As String, Directory As String) As String
   Dim strBuffer As String
   strBuffer = String(750&, Chr(0))
   Key$ = LCase$(Key$)
   GetFromINI$ = Left(strBuffer, GetPrivateProfileString(Section$, ByVal Key$, "", strBuffer, Len(strBuffer), Directory$))
End Function

Public Sub WriteToINI(Section As String, Key As String, KeyValue As String, Directory As String)
    Call WritePrivateProfileString(Section$, UCase$(Key$), KeyValue$, Directory$)
End Sub

Public Sub GetPosition(FRM As Form, strDir As String)
    Dim bytWindowState As Byte
    Dim intLeft As Integer
    Dim intTop As Integer
    Dim intWidth As Integer
    Dim intHeight As Integer
    bytWindowState = CByte(GetFromINI("pos", "windowstate", strDir$))
    intLeft% = CInt(GetFromINI("pos", "left", strDir$))
    intTop% = CInt(GetFromINI("pos", "top", strDir$))
    intWidth% = CInt(GetFromINI("pos", "width", strDir$))
    intHeight% = CInt(GetFromINI("pos", "height", strDir$))
    With FRM
        .Move intLeft%, intTop%, intWidth%, intHeight%
        .WindowState = bytWindowState
    End With
End Sub

Public Sub SetPosition(FRM As Form, strDir As String)
    With FRM
        Select Case .WindowState
            Case 0
                Call WriteToINI("pos", "windowstate", CStr(.WindowState), strDir$)
                Call WriteToINI("pos", "left", CStr(.Left), strDir$)
                Call WriteToINI("pos", "top", CStr(.Top), strDir$)
                Call WriteToINI("pos", "width", CStr(.Width), strDir$)
                Call WriteToINI("pos", "height", CStr(.Height), strDir$)
            Case 1
                Call WriteToINI("pos", "windowstate", CStr(.WindowState), strDir$)
            Case 2
                Call WriteToINI("pos", "windowstate", CStr(.WindowState), strDir$)
        End Select
    End With
End Sub

